﻿using StockSharp.Algo;
using StockSharp.Algo.Candles;
using StockSharp.Algo.Storages;
using StockSharp.BusinessEntities;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace NewCHU
{
    /// <summary>
    /// Логика взаимодействия для MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        Connector connector;
        CandleSeries candleSeries;
        StorageRegistry storage;
        decimal sum = 0;
        public MainWindow()
        {
            InitializeComponent();
            connector = new Connector();
        }

        private void Action_Click(object sender, RoutedEventArgs e)
        {
            try
            {
               // Security security = new Security();
                storage = new StorageRegistry();
                var path = System.IO.Path.GetFullPath(@"C:\Users\KalDarckli\Desktop\Hystory");
                ((LocalMarketDataDrive)storage.DefaultDrive).Path = path;

                var security = storage.GetSecurityStorage().LookupByCode("RIZ8").First();
               
                var candles = storage.GetCandleStorage(typeof(TimeFrameCandle), security, TimeSpan.FromTicks(1));
                From_d.Value = candles.Dates.First();
                To_d.Value = candles.Dates.Last();

                candleSeries = new CandleSeries(typeof(TimeFrameCandle), security, TimeSpan.FromTicks(1));
                EntityRegistry er = new EntityRegistry();
                SnapshotRegistry sr = new SnapshotRegistry(path);
                connector.InitializeStorage(er, storage, sr);
                connector.CandleSeriesProcessing += Connector_CandleSeriesProcessing;
                connector.SubscribeCandles(candleSeries, (DateTime)From_d.Value, (DateTime)To_d.Value);
            }
            catch(Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
        }

        private void Connector_CandleSeriesProcessing(CandleSeries arg1, Candle candle)
        {
            sum += (decimal)candle.CloseVolume;
        }

        private void CheckAction_Click(object sender, RoutedEventArgs e)
        {
            MessageBox.Show(sum.ToString());
        }
    }
}
